##
## THIS FILE IS UNDER PUPPET CONTROL. DON'T EDIT IT HERE.
## USE: git clone git+ssh://$USER@puppet.debian.org/srv/puppet.debian.org/git/dsa-puppet.git
##

Port 22

<% @extraports.each do |port| -%>
ListenAddress <%= port %>
<% end -%>
# Use these options to restrict which interfaces/protocols sshd will bind to
Protocol 2

HostKey /etc/ssh/ssh_host_rsa_key
<%- if has_variable?("has_etc_ssh_ssh_host_ed25519_key") && @has_etc_ssh_ssh_host_ed25519_key -%>
HostKey /etc/ssh/ssh_host_ed25519_key
<% end %>
<% if classes.include?("roles::ssh_upload") or classes.include?("roles::salsa") or classes.include?("roles::dsa_gitolite") -%>
# On ssh upload hosts we have many clients doing ssh connections to us.
# sshd has - by default - a limit of 10 on the number of currently
# unauthenticated (or not yet authenticated) connections.  Raise that limit.
MaxStartups 100:30:200
<% end %>

LogLevel VERBOSE

# Authentication:
PermitRootLogin without-password

ChallengeResponseAuthentication no

PrintMotd no

#MaxStartups 10:30:60

AcceptEnv LANG LC_*

Subsystem sftp /usr/lib/openssh/sftp-server

UsePAM yes

AuthorizedKeysFile /etc/ssh/userkeys/%u /var/lib/misc/userkeys/%u /etc/ssh/userkeys/%u.more /etc/ssh/puppetkeys/%u
TrustedUserCAKeys /etc/ssh/sshca_keys

ExposeAuthInfo yes

PasswordAuthentication no

<%=
  allnodeinfo = scope.lookupvar('deprecated::allnodeinfo')
  out = ''
  settings = '#  Banner "You are coming from a debian.org host."'
  allnodeinfo.keys.sort.each do |node|
      next if allnodeinfo[node]['ipHostNumber'].to_a.empty?
      out += "# Match Address "
      out += allnodeinfo[node]['ipHostNumber'].collect do |ipnum|
          if ipnum =~ /:/
              "#{ipnum}/128"
          else
              "#{ipnum}/32"
          end
      end.join(',')
      out += " # #{node}"
      out += "\n"
      out += settings
      out += "\n\n"
  end
  out
%>

Match Group sftponly
  AllowStreamLocalForwarding no
  AllowTCPForwarding no
  X11Forwarding no
  ForceCommand internal-sftp
<% if classes.include?("roles::salsa") -%>

Match User git
  AuthorizedKeysCommand /usr/local/sbin/gitlab-shell-authorized-keys-check git %u %k
  AuthorizedKeysCommandUser git
  # Do not read any file, all keys for git go via the above command
  AuthorizedKeysFile none
  DisableForwarding yes
  PermitTTY no
  AcceptEnv GIT_PROTOCOL
<% end %>
